;##################################################################
;
;   ZMercury (Enemy bullete)
;
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   Copyright 2004 by Patrick Davidson.  This software may be freely
;   modified and/or copied with no restrictions.  There is no warranty.
;
;   This file was last updated February 24, 2004.
;
;##################################################################     

;############## Enemy bullet handling
;
; Iterates through the array of enemy bullets.

process_enemy_bullets:
        ld      hl,enemy_bullets
        ld      b,eb_num
loop_enemy_bullets:
        ld      a,(hl)                  ; test if enemy exists
        or      a
        jr      z,no_enemy_bullet
        push    bc

        push    hl
        ld      b,a
        and     15                      ; X-movement
        inc     hl
        sub     (hl)
        jr      nc,ebk
        neg
        ld      (hl),a
        ld      d,a

        ld      a,b                     ; Y-movement
        inc     hl
        inc     hl
        sra     a
        sra     a
        sra     a
        sra     a
        add     a,(hl)
        ld      (hl),a
        ld      e,a

        cp      MIN_Y-10
        jr      c,ebk
        cp      MAX_Y
        jr      nc,ebk

        inc     hl                      ; draw sprite
        inc     hl
        inc     hl
        call    DO_LD_HL_MHL
        call    drw_spr
        pop     hl                     

        push    hl                      ; check enemy/player collision
        inc     hl
        call    collision_check
        pop     hl
        jr      nc,enemy_bullet_done

        push    hl
        ld      (hl),0
        ld      de,eb_dmg
        add     hl,de
        ld      b,(hl)
loop_damage_you:
        push    bc
        call    hit_player
        pop     bc
        djnz    loop_damage_you
no_f_collision:
        pop     hl

enemy_bullet_done:
        pop     bc
no_enemy_bullet
        ld      de,eb_size
        add     hl,de
        djnz    loop_enemy_bullets
        ret

ebk:    pop     hl
        ld      (hl),0
        jr      enemy_bullet_done
