;##################################################################
;
;   ZMercury (terrain code)
;                                                                     
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   Copyright 2004 by Patrick Davidson.  This software may be freely
;   modified and/or copied with no restrictions.  There is no warranty.
;
;   This file was last updated September 17, 2004.
;
;##################################################################     

scroll_terrain:
        ld      hl,(terr_buffer)
        ld      de,TERRAIN_SIZE
        add     hl,de
        ld      b,TERRAIN_HEIGHT
        call    scroll_buffer

        ld      hl,terrain_count
        inc     (hl)
        ld      a,(hl)
        cp      8
        ret     nz
        ld      (hl),0

        ld      a,(game_status)
        or      a
        jr      z,not_stopped
        ld      a,(enemies_left)
        or      a
        jr      nz,terrain_stopped
        ld      (game_status),a
not_stopped:

        inc     hl
        ld      a,(hl)
        inc     a
        cp      TERRAIN_WIDTH
        jr      nz,terrain_ok
        xor     a
terrain_ok:
        ld      (hl),a

        ld      hl,terrain_map
        call    ADD_HL_A                ; HL => this columns start in map
        ex      de,hl
        ld      hl,(terr_buffer)
        ld      bc,BUFF_WIDTH-1         
        add     hl,bc                   ; HL => end of line on top row
        ex      de,hl                   ; DE => end of line on top row
        ld      b,TERRAIN_TILES
column_loop:
        ld      a,(hl)                  ; A = brick #
        push    hl
        push    bc
        ld      hl,tile_images
        add     a,a
        add     a,a
        add     a,a
        call    ADD_HL_A                ; HL => brick image
        ld      b,8                     
block_loop:
        ldi                             ; copy one row, advance pointers
        ld      a,BUFF_WIDTH-1          ; add 16 to DE (next screen line)
        add     a,e
        ld      e,a
        jr      nc,bld
        inc     d
bld:    djnz    block_loop
        pop     bc
        pop     hl
        ld      a,TERRAIN_WIDTH         ; move to next row of map
        call    ADD_HL_A
        djnz    column_loop

        ld      a,(hl)
        or      a
        jp      nz,enemy_entry
        ret

terrain_stopped:
        ld      hl,(terr_buffer)
        ld      bc,BUFF_WIDTH-1
        add     hl,bc                   ; HL => end of line on top row
        ld      a,255
        ld      b,TERRAIN_HEIGHT
        ld      de,BUFF_WIDTH
loop_terr_stopped:
        ld      (hl),a
        add     hl,de
        djnz    loop_terr_stopped
        ret

;############## Level data

tile_images:
        .include "terrain.inc"

terrain_map:
        .include "map0.inc"

TERRAIN_WIDTH   =64
