;##################################################################
;
;   ZMercury (main code)
;                                                                     
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   Copyright 2004 by Patrick Davidson.  This software may be freely
;   modified and/or copied with no restrictions.  There is no warranty.
;
;   This file was last updated November 27, 2004.
;
;##################################################################     

main:   ld      hl,timer_interrupt      ; Initialize interrupt
        call    INT_INSTALL
        
        ld      hl,saved_flag
        ld      (hl),0
        ld      bc,saved_end-saved_flag-1
        call    OTH_FILL

        ROM_CALL(CLEARLCD)
        call    initialize_display_buffers

        ld      a,-1
        ld	(terrain_x),a
        ld      (contrastkeys),a
        xor     a
        ld      (timer),a
        ld      a,3
        ld      (terrain_count),a
        ld      a,42
        ld      (player_x),a
        ld      a,60
        ld      (player_y),a
        ld      hl,$1
        ld      (shield),hl

        ld      hl,zero_start
        ld      (hl),0
        ld      de,zero_start+1
        ld      bc,saved_end-zero_start-1
        ldir

        call    title_screen

        call    show_panel

;############## The main loop

main_loop:
        ld      hl,(game_timer)
        inc     hl
        ld      (game_timer),hl
        call    scroll_terrain
        call    scroll_stars
        call    draw_background
        call    move_player
        call    handle_player_bullets
        call    process_enemies
        call    process_enemy_bullets
        call    hit_enemy

        call    wait_next_frame
#ifndef NARROW
        ld      hl,$ffa0
        ld      bc,15
        ld      (hl),0
        call    OTH_FILL
        ld      a,(speed)
        inc     a
        ld      hl,$ffaf
b:      ld      (hl),-1
        dec     hl
        dec     a
        jr      nz,b
#endif
        call    display_buffer
        call    show_lives
        call    show_score
        ld      a,(shield)
        rla
        jr      nc,main_loop

;############## Game over screen

game_over:
        call    INT_REMOVE
        call    OTH_ARROW
        bit     6,a
        ret     z

        call    enter_table
        call    show_table
loopexit:
        call    GET_KEY
        or      a
        jr      z,loopexit
        ret

;############## The very simple interrupt

timer_interrupt:
        push    hl
        ld      hl,timer
        inc     (hl)
        pop     hl
        ret
